/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2026 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "can.h"
#include "dma.h"
#include "i2c.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "AS5600.h"
#include "log.h"
#include <stdint.h>
#include "can_node.h"
#include "cmd.h"
#include "flash.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
extern uint8_t g_debugLevel;
extern uint8_t g_direction;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
uint8_t can_checksum_calculate(uint8_t *data, uint8_t length)
{
  uint8_t sum = 0;
  for (uint8_t i = 0; i < length; i++)
  {
    sum += data[i];
  }
  return sum & 0xff;
}

float as5600_velocity(uint16_t a2, uint16_t a1, float dt_s)
{
    if (dt_s <= 0.0f) return 0.0f;

    int32_t d = (int32_t)a2 - (int32_t)a1;

    // AS5600 12bit回绕修正：取最短路径差值
    if (d > 2048) d -= 4096;
    else if (d < -2048) d += 4096;

    // 返回单位：rps (revolutions per second)
    return ((float)d / 4096.0f) / dt_s;
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  /* USER CODE BEGIN 1 */
  int status = -1;
  uint16_t angle = 0;
  uint16_t prev_angle = 0;
  uint32_t prev_tick_ms = 0;
  float velocity_deg_s = 0.0f;
  FlashConfig_t *flashConfig = NULL;
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_CAN1_Init();
  MX_I2C2_Init();
  MX_USART1_UART_Init();
  /* USER CODE BEGIN 2 */
  can_node_init();
  init_cmd();
  flashConfig = Flash_ReadConfig();
  _dbg_printf("Current CAN ID: 0x%02X\r\n", flashConfig->can_id);
  status = -1;
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    switch (status)
    {
    case -1:
      if (AS5600_Init() == 0)
      {
        prev_angle = AS5600_GetAngle();
        
        status = 0;
      }
      else
      {
        status = -1;
        // _dbg_printf("AS5600 Initialization Failed!\r\n");
        HAL_GPIO_TogglePin(LED_R_GPIO_Port, LED_R_Pin);
        HAL_Delay(100);
      }
      break;
    case 0:
      {
        HAL_GPIO_WritePin(LED_R_GPIO_Port, LED_R_Pin, GPIO_PIN_SET);
        prev_tick_ms = HAL_GetTick();
        angle = AS5600_GetAngle();
        HAL_Delay(5); // 10ms采样周期
        uint32_t now_ms = HAL_GetTick();
        uint32_t dt_ms = now_ms - prev_tick_ms;
        if (dt_ms > 0U)
        {
          velocity_deg_s = as5600_velocity(angle, prev_angle, (float)dt_ms * 0.001f) * 360.0f;
        }

        prev_angle = angle;
        prev_tick_ms = now_ms;
        if(g_direction > 0)
        {
          // 反转方向
          velocity_deg_s = -velocity_deg_s;
          angle = -angle;
        }
        if(g_debugLevel > 0)
        {
          _dbg_printf("Angle: %u, Vel: %.2f dt: %u ms\r\n", angle, velocity_deg_s, dt_ms);
        }
        HAL_GPIO_TogglePin(LED_G_GPIO_Port, LED_G_Pin);
        status = 1;
      }
      break;
    case 1:
      {
        uint8_t canData[8] = {0};
        int16_t vel_cdeg_s = (int16_t)(velocity_deg_s * 100.0f); // 0.01 deg/s
        int transmitResult = 0;

        canData[0] = 0xAA; // 头
        canData[1] = (angle >> 8) & 0xFF;
        canData[2] = angle & 0xFF;
        canData[3] = (vel_cdeg_s >> 8) & 0xFF;
        canData[4] = vel_cdeg_s & 0xFF;
        canData[5] = 0x00; // 保留
        canData[6] = 0x00; // 保留
        canData[7] = can_checksum_calculate(canData, 7);

        transmitResult = can_node_transmit(flashConfig->can_id, canData);
        if (transmitResult != 0)
        {
            status = -1; // 发送失败，回到初始化状态
            status = 2; // 直接进入错误状态，持续闪烁蓝灯
        }
        else
        {
            status = 0;
            HAL_GPIO_WritePin(LED_B_GPIO_Port, LED_B_Pin, GPIO_PIN_SET);  //关闭蓝灯
        }
      }
      break;
    case 2:
      HAL_GPIO_TogglePin(LED_B_GPIO_Port, LED_B_Pin);
      // HAL_Delay(100);
      break;
    default:
      break;
    }
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 3;
  RCC_OscInitStruct.PLL.PLLN = 20;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV7;
  RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}
#ifdef USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
